/*
 * esercizio.cpp
 *
 *  Scopo: Si scriva una funzione test(Character& c) che muove il personaggio alle coordinate 3, 4.
 *  Si invochi la funzione passando sia un oggetto di tipo Character allocato staticamente che con "test(4)".
 *  Modificare il codice della classe Character per evitare la conversione implicita che accade nella chiamata "test(4)".
 *
 */

#include <iostream>

#include "Character.h"

void test(Character c);
// void test(Character& c); // use a reference to change the object passed as argument

int main() {
	Character hero(4);
	std::cout << "Hero x:" << hero.getX() << " - y: " << hero.getY() << std::endl;
	test(hero);
	std::cout << "Hero x:" << hero.getX() << " - y: " << hero.getY() << std::endl;

	// Try to remove "explicit" from the declaration for the constructor
	// un-comment the following line and recompile...
	// test(4);

	// Bonus: use dynamically allocated Character
	Character* anotherHero = new Character(4);
	std::cout << "anotherHero x:" << anotherHero->getX() << " - y: " << anotherHero->getY() << std::endl;
	test(*anotherHero);
	std::cout << "anotherHero x:" << anotherHero->getX() << " - y: " << anotherHero->getY() << std::endl;
	delete anotherHero;
}

// TODO try different versions of this function
void test(Character c) {
// void test(Character& c) { // use a reference to change the object passed as argument
	c.move(3, 4);
}

